/********************************** (C) COPYRIGHT *******************************
* File Name          : USBCOM.C
* Author             : WCH
* Version            : V1.0
* Date               : 2015/05/20
* Description        : CH559ģ⴮
*******************************************************************************/
#include <CH559.H>
#include <string.h>
#include "DEBUG.C"


#define THIS_ENDP0_SIZE         DEFAULT_ENDP0_SIZE

UINT8X	Ep0Buffer[THIS_ENDP0_SIZE] _at_ 0x0000;                                //˵0 OUT&INżַ
UINT8X	Ep2Buffer[2*MAX_PACKET_SIZE] _at_ 0x0008;                              //˵2 IN&OUT,żַ
UINT8X  Ep1Buffer[MAX_PACKET_SIZE] _at_ 0x00a0;

UINT8	  SetReqtp,SetupReq,SetupLen,UsbConfig,Flag;
PUINT8  pDescr;	                                                               
UINT8   num = 0;
UINT8   LEN = 0;
USB_SETUP_REQ	           SetupReqBuf;                                          //ݴSetup
#define UsbSetupBuf     ((PUSB_SETUP_REQ)Ep0Buffer)

 
UINT8C DevDesc[18]={0x12,0x01,0x10,0x01,0xff,0x00,0x02,0x08,                   //豸
                    0x86,0x1a,0x23,0x55,0x04,0x03,0x00,0x00,
                    0x00,0x01};

UINT8C CfgDesc[39]={0x09,0x02,0x27,0x00,0x01,0x01,0x00,0x80,0xf0,              //ӿ,˵
	                  0x09,0x04,0x00,0x00,0x03,0xff,0x01,0x02,0x00,           
                    0x07,0x05,0x82,0x02,0x20,0x00,0x00,                        //ϴ˵
		                0x07,0x05,0x02,0x02,0x20,0x00,0x00,                        //´˵      
			              0x07,0x05,0x81,0x03,0x08,0x00,0x01};                       //жϴ˵

UINT8C DataBuf[26]={0x30,0x00,0xc3,0x00,0xff,0xec,0x9f,0xec,0xff,0xec,0xdf,0xec,
                    0xdf,0xec,0xdf,0xec,0x9f,0xec,0x9f,0xec,0x9f,0xec,0x9f,0xec,
                    0xff,0xec};
UINT8 RecBuf[64];
/*******************************************************************************
* Function Name  : USBDeviceCfg()
* Description    : USB豸ģʽ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceCfg()
{
    USB_CTRL = 0x00;                                                           //USBƼĴ
    USB_CTRL &= ~bUC_HOST_MODE;                                                //λΪѡ豸ģʽ
    USB_CTRL |=  bUC_DEV_PU_EN | bUC_INT_BUSY | bUC_DMA_EN;					           //USB豸ڲʹ,жڼжϱ־δǰԶNAK
    USB_DEV_AD = 0x00;                                                         //豸ַʼ

    UDEV_CTRL &= ~bUD_RECV_DIS;                                                //ʹܽ
//  USB_CTRL |= bUC_LOW_SPEED;    
//  UDEV_CTRL |= bUD_LOW_SPEED;                                                //ѡ1.5Mģʽ

    USB_CTRL &= ~bUC_LOW_SPEED;
    UDEV_CTRL &= ~bUD_LOW_SPEED;                                               //ѡȫ12MģʽĬϷʽ

    UDEV_CTRL |= bUD_DP_PD_DIS | bUD_DM_PD_DIS;                                //ֹDMDP
    UDEV_CTRL |= bUD_PORT_EN;                                                  //ʹ˿
}


/*******************************************************************************
* Function Name  : USBDeviceIntCfg()
* Description    : USB豸ģʽжϳʼ
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceIntCfg()
{
    USB_INT_EN |= bUIE_SUSPEND;                                                //ʹ豸ж
    USB_INT_EN |= bUIE_TRANSFER;                                               //ʹUSBж
    USB_INT_EN |= bUIE_BUS_RST;                                                //ʹ豸ģʽUSB߸λж
    USB_INT_FG |= 0x1F;                                                        //жϱ־
    IE_USB = 1;                                                                //ʹUSBж
    EA = 1; 																                                   //Ƭж
}


/*******************************************************************************
* Function Name  : USBDeviceEndPointCfg()
* Description    : USB豸ģʽ˵
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USBDeviceEndPointCfg()
{
    UEP2_DMA = Ep2Buffer;                                                      //˵2ݴַ																			                                         
    UEP2_3_MOD |= bUEP2_TX_EN;                                                 //˵2ʹ
    UEP2_3_MOD |= bUEP2_RX_EN;                                                 //˵2ʹ
    UEP2_3_MOD &= ~bUEP2_BUF_MOD;                                              //˵264ֽڷͻ64ֽڽջ128ֽ
    UEP2_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK;								 //˵2Զתͬ־λIN񷵻NAKOUTACK
	
	
	  UEP1_DMA = Ep1Buffer;                                                      //˵1ݴַ																			                                         
    UEP4_1_MOD |= bUEP1_TX_EN;                                                 //˵1ʹ
//  UEP4_1_MOD |= bUEP1_RX_EN;                                                 //˵1ʹ
    UEP4_1_MOD &= ~bUEP1_BUF_MOD;                                              //˵164ֽڷͻ
    UEP1_CTRL = bUEP_AUTO_TOG | UEP_T_RES_NAK | UEP_R_RES_ACK;								 //˵1Զתͬ־λIN񷵻NAKOUTACK
	
	
    UEP0_DMA = Ep0Buffer;                                                      //˵0ݴַ
    UEP4_1_MOD &= ~(bUEP4_RX_EN | bUEP4_TX_EN);								                 //˵064ֽշ
    UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;                                 //OUT񷵻ACKIN񷵻NAK
}


/*******************************************************************************
* Function Name  : SendData( PUINT8 SendBuf )
* Description    : ݸ
* Input          : PUINT8 SendBuf
* Output         : None
* Return         : None
*******************************************************************************/
void SendData( PUINT8 SendBuf )
{
	 if(Flag==1)                             
	 {
     while(LEN > 32){		 
     memcpy(&Ep2Buffer[MAX_PACKET_SIZE],SendBuf,32);
	   UEP2_T_LEN = 32;
	   UEP2_CTRL &= ~(bUEP_T_RES1 | bUEP_T_RES0);	
     while(( UEP2_CTRL & MASK_UEP_T_RES ) == UEP_T_RES_ACK);                  //
     LEN -= 32;
     }
     memcpy(&Ep2Buffer[MAX_PACKET_SIZE],SendBuf,LEN);
	   UEP2_T_LEN = LEN;
	   UEP2_CTRL &= ~(bUEP_T_RES1 | bUEP_T_RES0);		 		
     Flag = 0;		 
   }
}


/*******************************************************************************
* Function Name  : RecieveData()
* Description    : USB豸ģʽ˵
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void RecieveData()
{
	  memcpy(RecBuf,Ep2Buffer,USB_RX_LEN); 
	  UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_R_RES | UEP_R_RES_NAK;                    //ĬӦACK
	  Flag = 1;
}


/*******************************************************************************
* Function Name  : DeviceInterrupt()
* Description    : CH559USBжϴ
*******************************************************************************/
void	DeviceInterrupt( void ) interrupt INT_NO_USB using 1                       //USBжϷ,ʹüĴ1
{   
	UINT8 len; 
	if(UIF_TRANSFER)                                                               //USBɱ־
  {
    switch (USB_INT_ST & (MASK_UIS_TOKEN | MASK_UIS_ENDP))
    {
			 case UIS_TOKEN_OUT | 2:                                                   //endpoint 2# ж´					 
						LEN = USB_RX_LEN; 
			      RecieveData();
            SendData(RecBuf);			 
						break;
		   case UIS_TOKEN_IN | 2:                                                    //endpoint 2# жϴ
            UEP2_T_LEN = 0;	                                                     //Ԥʹ÷ͳһҪ						 
	          UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_R_RES | UEP_R_RES_ACK;                    //ĬӦACK					 
    			  UEP2_CTRL = UEP2_CTRL & ~ MASK_UEP_T_RES | UEP_T_RES_NAK;            //ĬӦNAK
						break;
    	 case UIS_TOKEN_SETUP | 0:                                                  //SETUP
            len = USB_RX_LEN;
            if(len == (sizeof(USB_SETUP_REQ)))
            {   
							 SetReqtp = UsbSetupBuf->bRequestType;
               SetupLen = UsbSetupBuf->wLengthL;
               len = 0;                                                           //ĬΪɹϴ0,׼                                                              
               SetupReq = UsbSetupBuf->bRequest;
               if(SetReqtp == 0xc0)
						   {
								  Ep0Buffer[0] = DataBuf[num];
								  Ep0Buffer[1] = DataBuf[num+1];
								  len = 2;
								  if(num<24)
								  {	
								    num += 2;
									}
									else
									{
										num = 24;
									}
						   }
					     else if(SetReqtp == 0x40)
						   {
							    len = 9;                                                        //֤״̬׶ΣֻҪ8Ҳ0xff
						   }
						   else
						   { 
							    switch(SetupReq)                                                //
							    {
								     case USB_GET_DESCRIPTOR:
											    switch(UsbSetupBuf->wValueH)
											    {
													   case 1:	                                            //豸
																 pDescr = DevDesc;                                //豸͵Ҫ͵Ļ
																 len = sizeof(DevDesc);								       
													   break;	 
													   case 2:									                            //
																 pDescr = CfgDesc;                                //͵Ҫ͵Ļ
																 len = sizeof(CfgDesc);
													   break;	
													   default:
																 len = 0xff;                                      //ֵ֧߳
													   break;
											     }
									         if ( SetupLen > len ) SetupLen = len;                  //ܳ
									         len = SetupLen >= 8 ? 8 : SetupLen;                    //δ䳤
									         memcpy(Ep0Buffer,pDescr,len);                          //ϴ
									         SetupLen -= len;
									         pDescr += len;
										       break;						 
							        case USB_SET_ADDRESS:
										       SetupLen = UsbSetupBuf->wValueL;                       //ݴUSB豸ַ
										       break;
							        case USB_GET_CONFIGURATION:
									         Ep0Buffer[0] = UsbConfig;
									         if ( SetupLen >= 1 ) len = 1;
									         break;
							        case USB_SET_CONFIGURATION:
									         UsbConfig = UsbSetupBuf->wValueL;
									         break;
							        default:
										       len = 0xff;                                            //ʧ
										       break;    
							       }
					        }
				      }
					    else
					    {
							    len = 0xff;                                                     //ȴ
					    }

						  if(len == 0xff)
						  {
								  SetupReq = 0xFF;
								  UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_STALL | UEP_T_RES_STALL;//STALL				     
						  }
						  else if(len <= 8)                                                         //ϴݻ״̬׶η0Ȱ
						  {
								  UEP0_T_LEN = len;
								  UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  //ĬݰDATA1ӦACK
						  }
						  else
						  {
								  UEP0_T_LEN = 0;                                                       //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
								  UEP0_CTRL = bUEP_R_TOG | bUEP_T_TOG | UEP_R_RES_ACK | UEP_T_RES_ACK;  //ĬݰDATA1,ӦACK				     
						  }
					    break;
				 case UIS_TOKEN_IN | 0:                                                         //endpoint0 IN
						  switch(SetupReq)
						  {
							   case USB_GET_DESCRIPTOR:
								      len = SetupLen >= 8 ? 8 : SetupLen;                               //δ䳤
											memcpy( Ep0Buffer, pDescr, len );                                 //ϴ
											SetupLen -= len;
											pDescr += len;
											UEP0_T_LEN = len;
											UEP0_CTRL ^= bUEP_T_TOG;                                          //ͬ־λת
								      break;
							   case USB_SET_ADDRESS:
											USB_DEV_AD = USB_DEV_AD & bUDA_GP_BIT | SetupLen;
											UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
								      break;
							   default:
								      UEP0_T_LEN = 0;                                                    //״̬׶жϻǿϴ0ݰƴ
								      UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_NAK;
								      break;
						  }
						  break;
				 case UIS_TOKEN_OUT | 0:                                                 // endpoint0 OUT
							len = USB_RX_LEN;
							UEP0_T_LEN = 0;                                                    //Ȼδ״̬׶ΣǰԤϴ0ݰԷǰ״̬׶
							UEP0_CTRL = UEP_R_RES_ACK | UEP_T_RES_ACK;                         //ĬݰDATA0,ӦACK									
						  break;
					default:
						  break;
				}
				UIF_TRANSFER = 0;                                                        //д0ж  
    }
    if(UIF_BUS_RST)                                                              //豸ģʽUSB߸λж
    {
			USB_DEV_AD = 0x00;
			UIF_SUSPEND = 0;
			UIF_TRANSFER = 0;
			UIF_BUS_RST = 0;                                                           //жϱ־
    }
	  if (UIF_SUSPEND) 
		{                                                                            //USB߹/
			UIF_SUSPEND = 0;
			if ( USB_MIS_ST & bUMS_SUSPEND ) 
			{                                                                          //
				while ( XBUS_AUX & bUART0_TX );                                          //ȴ
				SAFE_MOD = 0x55;
				SAFE_MOD = 0xAA;
				WAKE_CTRL = bWAK_BY_USB | bWAK_RXD0_LO;                                  //USBRXD0źʱɱ
				PCON |= PD;                                                              //˯
				SAFE_MOD = 0x55;
				SAFE_MOD = 0xAA;
				WAKE_CTRL = 0x00;
			}
    } 
	  else 
	  {                                                                             //ж,ܷ
		  USB_INT_FG = 0x00;                                                          //жϱ־
	  }      
}


void main()
{
	  mDelaymS(30);                                                                 //ϵʱ
//  CfgFsys( );                                                                   //CH559ʱѡ    
    mInitSTDIO( );                                                                //0,ڵ
	  USBDeviceCfg();                                                               //豸ģʽ
    USBDeviceEndPointCfg();														                            //˵
    USBDeviceIntCfg();															                              //жϳʼ
	  UEP0_T_LEN = 0;
    UEP1_T_LEN = 0;	                                                              //Ԥʹ÷ͳһҪ	
    UEP2_T_LEN = 0;	                                                      
    while(1)
    {   
//         SendData(RecBuf);
// 		    mDelaymS( 500 );                                                         //ģⵥƬ				
    }
}

